VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsLvwScroll"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'-----------------------------------------------
'
'     clsLvwScroll.cls
'
'     Scrolling in einem Listview berwachen
'
'     Autor    peter.k.sauer@web.de
'     created  22.04.2004
'     update
'-----------------------------------------------
'     Option Explicit
'     Private WithEvents cLvw As clsLvwScroll
'
'     Private Sub cLvw_Scroll()
'
'           Debug.Print "Scrolling " & _
'                       Format(Timer, "0.000")
'     End Sub
'
'     Private Sub Form_Load()
'           'Activieren Class
'           Set cLvw = New clsLvwScroll
'           cLvw.Init ListView1, Timer1
'     End Sub
'     Private Sub Form_Unload(Cancel As Integer)
'
'           'Speicher freigeben
'           Set cLvw = Nothing
'     End Sub
'------------------------------------------------

Option Explicit

Public Event Scroll()                           'Event Scrolling

Private WithEvents myTimer As Timer             'Timer, wird bergeben
Attribute myTimer.VB_VarHelpID = -1
Private WithEvents myLvw As ListView            'Listview, wird bergeben
Attribute myLvw.VB_VarHelpID = -1

Private mvarCheckLvwScroll As Boolean           'Default = True
Private mvarIntervall As Long                   'Default = 100 (Millisekunden)
Private LastTopItem As Long                     'letztes TopItem

Public Property Let Intervall(ByVal vData As Long)
    mvarIntervall = vData
    myTimer.Interval = vData
End Property

Public Property Get Intervall() As Long
    Intervall = mvarIntervall
End Property

Public Property Let CheckLvwScroll(ByVal vData As Boolean)
      mvarCheckLvwScroll = vData
      'Timer an/aus
      myTimer.Enabled = vData
      LastTopItem = 0
End Property

Public Property Get CheckLvwScroll() As Boolean
    CheckLvwScroll = mvarCheckLvwScroll
End Property

'Class Ini
Public Sub Init(Lvw As ListView, mTimer As Timer)

      Set myLvw = Lvw
      Set myTimer = mTimer
      myTimer.Interval = mvarIntervall
      myTimer.Enabled = CheckLvwScroll
End Sub

Private Sub Class_Initialize()

      mvarIntervall = 100
      mvarCheckLvwScroll = True
End Sub

Private Sub Class_Terminate()

      myTimer.Enabled = False
      Set myTimer = Nothing
      Set myLvw = Nothing
End Sub

Private Sub myTimer_Timer()

   Dim i As Long
   
      'Listview nicht gefllt
      If myLvw.GetFirstVisible Is Nothing Then
         LastTopItem = 0
         Exit Sub
      End If
      
      i = myLvw.GetFirstVisible.Index
      '1. Zugriff
      If LastTopItem = 0 Then
         LastTopItem = i
         Exit Sub
      End If
      
      'Scrolling auslsen
      If LastTopItem <> i Then
         RaiseEvent Scroll
      End If
      LastTopItem = i
End Sub


